.prerequisite:
  image: node:lts-alpine
  services:
    - docker:${DOCKER_VERSION}-dind
  variables:
    DOCKER_HOST: tcp://docker:2376
    DOCKER_TLS_VERIFY: '1'
    DOCKER_TLS_CERTDIR: '/certs'
    DOCKER_CERT_PATH: '/certs/client'
    DOCKER_DRIVER: overlay2
    DOCKER_VERSION: '20.10.16'

.dagger:
  extends: [.prerequisite]
  before_script:
    - apk add docker-cli curl
    - cd /usr/local && { curl -L https://dl.dagger.io/dagger/install.sh | sh; cd -; }

build:
  extends: [.dagger]
  stage: build
  script:
    - yarn install --frozen-lockfile
    - dagger run node pipeline.mjs

seed:
  image: node:lts-alpine
  stage: build
  when: manual
  before_script:
    - npm install
  script: 
    - npm run seed